#include "world.h"
#include <cstdio>
#include <cstring>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

ofstream cout("output.txt");
	struct MyPoint {
		double x, y;
	};

double dist(MyPoint a, MyPoint b) {
	return (hypot(a.x-b.x,a.y-b.y));
}

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	World *world = new World(argv[1], atoi(argv[2]));
	float alpha = 0.0;

	//Infinite loop
	while (true) {
		cout << fixed << setprecision(2);
		double nx, ny, x, y,t,tx,ty;
		double steps = 200;
		//Send our turn and receive the update of the game world
		world->makeMove();

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);

		alpha += 0.008;
		//Run in circles (set direction)
		nx = cos(alpha); ny = sin(alpha);
		t = hypot(nx, ny);
		nx /= t; ny /= t;
		world->run(nx, ny);
		
		int pp = 0;
		for ( int k = 0; k < world->MAXMONSTERS; k++) {
			if (world->monsters[k].ClassName >= 0) {
				pp++;
			}
		}
		cout <<world->player.Time << ":" << pp << "\n";
		if (pp < 20)
		{
			//new code
			bool sh = false;
			for( int k = 0; k < world->MAXMONSTERS; k++)
				if (world->monsters[k].ClassName >= 0) {
					double ll, rr, eps, xx;
					for (double xx = 0; xx < 100; xx += 1e-3) {
						//xx = (rr - ll) / 2;
						tx = world->monsters[k].PositionX + world->monsters[k].VelocityX/60 * xx;
						ty = world->monsters[k].PositionY + world->monsters[k].VelocityY/60 * xx;
						t = hypot(world->player.PositionX - tx, world->player.PositionY - ty);
						if (fabs(xx * world->player.BulletVelocity/60 - t) < world->monsters[k].Radius + world->player.BulletRadius) {
							world->shoot(tx, ty);
							sh = true;
							cout << world->player.Time << " ";
							break;
						}
					}
					if (sh) break;
				}
			/*int ansk;
			double ans = 5;
			for( int k = 0; k < world->MAXMONSTERS; k++)
				if (world->monsters[k].ClassName >= 0) {
					t = hypot(world->monsters[k].PositionX - world->player.PositionX,
					world->monsters[k].PositionY - world->player.PositionY);
					if (t < ans) {
						ans = t;
						ansk = k;
					}
				}
			world->shoot(world->monsters[ansk].PositionX - world->player.PositionX,
						   world->monsters[ansk].PositionY - world->player.PositionY);*/
			/*for(int i=0;i<world->MAXMONSTERS;i++)
			{
				if (world->monsters[i].ClassName >= 0)
				{
					double x0x=world->monsters[i].PositionX, x0y=world->monsters[i].PositionY,
						v0x=world->monsters[i].VelocityX, v0y=world->monsters[i].VelocityY,
						x1x=world->player.PositionX, x1y=world->player.PositionY,
						dx=hypot(x0x-x1x, x0y-x1y), vm=hypot(v0x,v0y), vb=world->player.BulletVelocity,
						cx=((x0x-x1x)*vb)/(dx*(vb+vm)), cy= ((x0y-x1y)*vb)/(dx*(vb+vm)),
						A1=x0x-x1x, B1=x0y-x1y, C1=A1*cx+B1*cy,
						A2=v0y, B2=-v0x, C2=A2*x0x+B2*x0y,
						dd=A1*B2-A2*B1;
					if(fabs(dd)<0.0001)
					{
						world->shoot(world->monsters[i].PositionX - world->player.PositionX,
						   world->monsters[i].PositionY - world->player.PositionY);
					}	
					else
					{
						double x=(C1*B2-C2*B1)/dd, y=(A1*C2-A2*C1)/dd;
						world->shoot(x - world->player.PositionX,
						   y - world->player.PositionY);
					}
					goto end_loop;
				}
			}*/
			goto end_loop;
		}

		//Choose the first monster that is still alive
		double ans = 5;
		int ansj = 0;
		double alp[200];
		MyPoint pos[200];
		pos[0].x = world->player.PositionX;	pos[0].y = world->player.PositionY;
		alp[0] = alpha;
		t = hypot(world->player.VelocityX, world->player.VelocityY) / 60;
		tx = nx; ty = ny;
		for (int j = 1; j < steps; j++) {
			alp[j] = alp[j-1] + 0.008;
			pos[j].x = pos[j-1].x + tx * t; pos[j].y = pos[j-1].y + ty * t;
			tx = cos(alp[j-1]) / hypot(cos(alp[j-1]), sin(alp[j-1])); ty = sin(alp[j-1]) / hypot(cos(alp[j-1]), sin(alp[j-1]));
//			if (world->player.Time == 100) cout << fixed << setprecision(2) << pos[j].x << " " << pos[j].y << "; ";
		}
//		if (world->player.Time > 100 && world->player.Time <= 200) cout << fixed << setprecision(2) << pos[0].x << " " << pos[0].y;
//		cout << "\n";
		MyPoint mpos[world->MAXMONSTERS][200];
		MyPoint ppos[world->MAXMISSILES][200];
		double mhp[world->MAXMONSTERS][200];

		for ( int k = 0; k < world->MAXMONSTERS; k++)
			if (world->monsters[k].ClassName >= 0) {
				mpos[k][0].x = world->monsters[k].PositionX; mpos[k][0].y = world->monsters[k].PositionY;
				mhp[k][0] = world->monsters[k].HitPoints;
				for (int j = 1; j < steps; j++) {
					tx = pos[j-1].x - mpos[k][j-1].x; ty = pos[j-1].y - mpos[k][j-1].y;
					t = hypot(tx, ty);
					tx /= t; ty /= t;
					t = hypot(world->monsters[k].VelocityX, world->monsters[k].VelocityY) / 60;
					mpos[k][j].x = mpos[k][j-1].x + tx * t;
					mpos[k][j].y = mpos[k][j-1].y + ty * t;
					//if (world->player.Time == 100) cout << fixed << setprecision(2) << mpos[k][j].x << " " << mpos[k][j].y << "; ";
				}
				//if (world->player.Time == 100) cout << "\n";
				//if (world->player.Time > 100 && world->player.Time <= 200) cout << mpos[k][0].x << " " << mpos[k][0].y << "; ";
			} else mhp[k][0] = -1;
		//if (world->player.Time > 100 && world->player.Time <= 200) cout << "\n";
		for ( int k = 0; k < world->MAXMISSILES; k++)
			if (world->missiles[k].ClassName >= 0) {
				ppos[k][0].x = world->missiles[k].PositionX; ppos[k][0].y = world->missiles[k].PositionY;
			}

		/*for (int j = 1; j < steps; j++) {
			for (int k = 0; k < world->MAXMISSILES; k++)
			{
				if (ppos[k][j-1].x != -1) {
					ppos[k][j].x = ppos[k][j-1].x + world->missiles[k].VelocityX / 60;
					ppos[k][j].y = ppos[k][j-1].y + world->missiles[k].VelocityY / 60;
				} else {
					ppos[k][j].x = -1;
				}
				for (int l = 0; l < world->MAXMONSTERS; l++) {
					if (mhp[l][j] > 0 && dist(ppos[k][j], mpos[l][j]) < world->missiles[k].Radius + world->monsters[l].Radius) {
						mhp[l][j+1] = mhp[l][j] - world->missiles[k].Damage;
						ppos[k][j].x = -1;
					}
				}
			}
		}*/

		int jj,kk;
		jj = kk = -1;
		for (int j =0; j < steps; j++) {
			for ( int k = 0; k < world->MAXMONSTERS; k++)
				if (mhp[k][0] > 0 && dist(mpos[k][j], pos[j]) < world->monsters[k].Radius + world->player.Radius) {
					jj = j;
					kk = k;
					break;
				}
			if (jj != -1) break;
		}
		if ( jj != -1) cout << world->player.Time << " " << kk << " " << jj << " " << world->monsters[kk].HitPoints << " " << world->monsters[kk].PositionX << " " << world->monsters[kk].PositionY << "\n";
		bool f = false;

		if (jj != -1 ) {
		/*double dx,dy;
		for (int j =0; j < steps; j++) {
			int k = kk;
			t = dist(pos[0],mpos[k][j]);
			dx = mpos[k][j].x - pos[0].x; dy = mpos[k][j].y - pos[0].y;
			dx /= t; dy /= t;
			MyPoint pt;
			pt.x = pos[0].x + dx*world->player.BulletVelocity / 60;
			pt.y = pos[0].y + dy*world->player.BulletVelocity / 60;
			if (dist(pt, mpos[k][j]) < world->monsters[k].Radius + world->player.BulletRadius) {
				world->shoot(pt.x - world->player.PositionX,
						   pt.y - world->player.PositionY);
				f = true;
				break;
			}
		}
		*/			
			world->shoot(world->monsters[kk].PositionX - world->player.PositionX,
						   world->monsters[kk].PositionY - world->player.PositionY);
					f = true;
		}
if ( jj != -1) cout << f << "\n";
	if (!f) {
		for ( int j = 0; j < world->MAXMONSTERS; j++)
			if (world->monsters[j].ClassName >= 0) {
				t = hypot(world->monsters[j].PositionX - world->player.PositionX,
					world->monsters[j].PositionY - world->player.PositionY);
				double scal=(world->monsters[j].PositionX - world->player.PositionX)*nx-
					(world->monsters[j].PositionY - world->player.PositionY)*ny;
				t/=(scal+2);
				if (t < ans) {
						ans = t; ansj = j;
				}
				//Shoot the bastard! (Shoot in the direction of the monster)
				//break;
			}
		world->shoot(world->monsters[ansj].PositionX - world->player.PositionX,
						   world->monsters[ansj].PositionY - world->player.PositionY);
		}
end_loop:;
}

	return 0;
}
