#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
//#define Distance(m) ((world->monsters[m].PositionX - world->player.PositionX)*(world->monsters[m].PositionX - world->player.PositionX) + (world->monsters[m].PositionY - world->player.PositionY)*(world->monsters[m].PositionY - world->player.PositionY))
double Distance(int m);
World *world;
double eps = 1e-4;


int main(int argc, char** argv) {
		int raz = 1;


	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	world = new World(argv[1], atoi(argv[2]));
	float alpha = 0.0;

	//Infinite loop
	int num = -1;
	double dist;
	int prev=1000;
	bool center=false;
	double cx, cy;
	while (true) {

		//Send our turn and receive the update of the game world
		world->makeMove();

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf %.2lf",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY, dist);
	
		double Ecmx = 0, Ecmy = 0,  Em = 0;

		//Choose the first monster that is still alive

		
		
		double tmpdist;
		if(num == -1)
			dist = 100000;
		int counter = 1;
		for ( int j = 0; j < world->MAXMONSTERS; j++){
			if(world->monsters[j].ClassName >= 0){
				Ecmx += world->monsters[j].BiteDamage * world->monsters[j].PositionX;
				Ecmy += world->monsters[j].BiteDamage * world->monsters[j].PositionY;
				Em += world->monsters[j].BiteDamage;
				counter++;
			}
		}
		if (counter > prev)
		{
			raz++;
			center=true;
			cx=1- world->player.PositionX;
			cy=1- world->player.PositionY;

			if(raz == 3){
				cx = 0.25;
				cy = 0.5;
			}
		}
		if( fabs(world->player.PositionX - cx) < 2* world->player.VelocityX)//??
			center=false;

		if(!(num != -1 && world->monsters[num].HitPoints > 0 && dist < 0.15))
		{
			num=-1;
			dist = 100000;
			for ( int j = 0; j < world->MAXMONSTERS; j++){
				if (world->monsters[j].ClassName >= 0) {
					//Shoot the bastard! (Shoot in the direction of the monster)
					tmpdist = Distance(j);
					if(tmpdist < dist){
						dist = tmpdist;
						num = j;
					}
				}
			}
		}
		Ecmx = Ecmx / Em;
		Ecmy = Ecmy / Em;
		//world->run(world->player.PositionX - Ecmx, world->player.PositionY - Ecmy);
			dist = Distance(num);
			double time = dist/ world->player.BulletVelocity;
			double x = world->monsters[num].PositionX;
			double y = world->monsters[num].PositionY;
			if(dist > 0.03){
				x += world->monsters[num].VelocityX * time;
				y += world->monsters[num].VelocityY * time;
			}
			if(sqrt(dist) > eps)
				world->shoot(x - world->player.PositionX ,y - world->player.PositionY);
			else
				world->shoot(- world->player.PositionX + Ecmx, - world->player.PositionY + Ecmy);
		if(!center)
		{
			if((Ecmx - world->player.PositionX) * (Ecmx - world->player.PositionX) + (Ecmy - world->player.PositionY) * (Ecmy - world->player.PositionY) > 0.0667)
				world->run(-Ecmy + world->player.PositionY, Ecmx - world->player.PositionX);
			else
				world->run(world->player.PositionX - Ecmx, world->player.PositionY - Ecmy);
		}
		else
			world->run(cx - world->player.PositionX, cy - world->player.PositionY);


			printf("%.2lf %.2lf\n", Ecmx, Ecmy);
			prev = counter;
	}
	
	return 0;
}

double Distance(int m)
{
	double a=(world->monsters[m].PositionX - world->player.PositionX);
	double b=(world->monsters[m].PositionY - world->player.PositionY);
	return (a*a+b*b);
}
