#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>

using namespace std;

float sqr(float xx)
{
	return xx*xx;
}

int* last;

int best_monster(World* world,int cur)
{
	float myX = world->player.PositionX;
	float myY = world->player.PositionY;
	float mn = 1e9;
	int nearest = -1;
	for ( int j = 0; j < world->MAXMONSTERS; j++)
		if (world->monsters[j].ClassName >= 0 && 
			sqr(world->monsters[j].PositionX - myX) + sqr(world->monsters[j].PositionY - myY) < mn &&
			cur - last[j] > 4) {
			mn = sqr(world->monsters[j].PositionX - myX) + sqr(world->monsters[j].PositionY - myY);
			nearest = j;
		}
	return nearest;	
}

pair <float, float> gen_point(World* world)
{
	float myX = world->player.PositionX;
	float myY = world->player.PositionY;
	float myV = sqrt(sqr(world->player.VelocityX) + sqr(world->player.VelocityY));
	int i,j,u;
	int ii=0;
	int jj=0;
	float mn=1e19;
	for (i=9; i>=0; --i)
		for (j=9; j>=0; --j)
		{
			float dd = sqrt(sqr(myX - 0.1*i - 0.05) + sqr(myY - 0.1*j - 0.05));
			float tt = dd / myV;
			float value = 0;
			for (u=0; u<world->MAXMONSTERS; ++u)
				if (world->monsters[u].ClassName >= 0) 
				{
					if (i*0.1<=world->monsters[u].PositionX + tt*world->monsters[u].VelocityX && 
						world->monsters[u].PositionX + tt*world->monsters[u].VelocityX<=(i+1)*0.1 &&
						j*0.1<=world->monsters[u].PositionY + tt*world->monsters[u].VelocityY && 
						world->monsters[u].PositionY + tt*world->monsters[u].VelocityY<=(j+1)*0.1)
					{
						value+=1;
					}
				}
			value = value+tt;// * sqr(tt);
			if (value<mn)
			{
				mn = value;
				ii = i;
				jj = j;
			}
		}

/*	for (u=0; u<world->MAXMONSTERS; ++u)
		if (world->monsters[u].ClassName >= 0) 
		{
			sumX+=world->monsters[j]
		}
*/	return make_pair(ii*0.1+0.05, jj*0.1+0.05);
}

bool check(World* world)
{
	float myX = world->player.PositionX;
	float myY = world->player.PositionY;
	int ans[5];	
	memset(ans,0,sizeof(ans));
	for (int i=0; i<world->MAXMONSTERS; ++i)
	{
		if (world->monsters[i].ClassName >= 0)
		{
			float hisX = world->monsters[i].PositionX;
			float hisY = world->monsters[i].PositionY;
			float rad = 0.05;
			if (myX-hisX<rad && abs(myY-hisY)<rad/2)
				ans[0]++;
			if (hisX-myX<rad && abs(myY-hisY)<rad/2)
				ans[1]++;
			if (myY-hisY<rad && abs(myX-hisX)<rad/2)
				ans[2]++;
			if (hisY-myY<rad && abs(myX-hisX)<rad/2)
				ans[3]++;
		}
	}
	return ans[0]>1 && ans[1]>1 && ans[2]>1 && ans[3]>1;
}

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	World *world = new World(argv[1], atoi(argv[2]));
		
	float alpha = 0.0;

	last = new int[world->MAXMONSTERS];
	for (int i=0; i<world->MAXMONSTERS; ++i)
		last[i]=-100;
	int step = 0;

	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		world->makeMove();

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);

//		pair <float, float> p = gen_point(world);
//		float newX = p.first;
//		float newY = p.second;

		float myX = world->player.PositionX;
		float myY = world->player.PositionY;
		float myR = world->player.Radius;
//		if (abs(myX-0.5)<1e-6 && abs(myY-0.5)<1e-6)
//		{
//			world->run(1., 0.);
//		}
//		else 
		if (!check(world) || abs(myX)<myR+1e-6 || abs(myY)<myR+1e-6 ||
					abs(myX-1.)<myR+1e-6 || abs(myY-1.)<myR+1e-6)
		{
			float l = 0.0007;
			world->run(0.5-myY+l*(0.5-myX), myX-0.5+l*(0.5-myY));
		}
		else
		{
			float newX,newY;
			int ans[5];
			memset(ans,0,sizeof(ans));
			for (int i=0; i<world->MAXMONSTERS; ++i)
				if (world->monsters[i].ClassName>=0)
				{
					float hisX = world->monsters[i].PositionX;
					float hisY = world->monsters[i].PositionY;
					if (myX<hisX)
						ans[0]++;
					if (myX>hisX)
						ans[1]++;
					if (myY<hisY)
						ans[2]++;
					if (myY>hisY)
						ans[3]++;
				}
			int mn=int(1e9);
			int pplane=0;
			for (int i=0; i<4; ++i)
				if (ans[i]<mn)
				{
					mn=ans[i];
					pplane=i;
				}
			if (pplane==0)
			{
				newX = 1.;
				newY = 0.;
			}
			if (pplane==1)
			{
				newX = -1.;
				newY = 0.;
			}
			if (pplane==2)
			{
				newX = 0.;
				newY = 1.;
			}
			if (pplane==3)
			{
				newX = 0.;
				newY = -1.;
			}
			world->run(newX,newY);
		}
//		world->run(newX - world->player.PositionX, newY - world->player.PositionY);

		//Choose the first monster that is still alive
		int best = best_monster(world, step);
		if (best>=0)
		{
			last[best]=step++;
			float hisX = world->monsters[best].PositionX;
			float hisY = world->monsters[best].PositionY;
			float hisVX = world->monsters[best].VelocityX;
			float hisVY = world->monsters[best].VelocityY;
			float myX = world->player.PositionX;
			float myY = world->player.PositionY;
			float tt = sqrt(sqr(hisX-myX)+sqr(hisY-myY))/world->player.BulletVelocity;
			
			world->shoot(hisX+hisVX*0.001-myX, hisY+hisVY*0.001-myY);
		}
	}

	return 0;
}
