uses World;
var myworld : TWorld;
	port : longint;
	e, j, min : integer;
	xmin : real;
  alpha: real = 0.0;
begin
	{Check for enough parameters}
	if ParamCount < 2 then
    begin
		writeln('Parameters : ip port');
		halt(10);
	end;

	{Get port number}
	Val(ParamStr(2), port, e); 

	if (e <> 0) then
	begin
		writeln('Wrong port number!');
		halt(10);
	end;

	{Establish connection with the server}
	Open(ParamStr(1), port);

  alpha:=pi/4;

	{Infinite loop}
	while (true) do
	begin
		{Send our turn and receive the update of the game world}
		makeMove(myworld);

		{Print some information}
		writeln('Frame ', myworld.player.Time, ' HP: ', myworld.player.HitPoints:0:3, ' x: ', myworld.player.PositionX:0:3, ' y: ', myworld.player.PositionY:0:3);

		{Run in circles (set direction)}
		alpha := alpha +  0.02;
//		run(myworld, 0.5/pi*cos(alpha)-alpha*sin(alpha)/2/pi, 0.5/pi*sin(alpha)+alpha*cos(alpha)/2/pi);
    run(myworld, -sin(alpha)*cos(alpha/2)/abs(cos(alpha/2)),cos(alpha));
		{Choose the first monster that is still alive}
    min := 0;
    xmin := 100;
		for  j := 1 to MAXMONSTERS do
			if (myworld.monsters[j].ClassName > 0) then
			begin
				{Shoot the bastard! (Shoot in the direction of the monster)}

        if (sqrt((myworld.monsters[j].PositionX - myworld.player.PositionX)*(myworld.monsters[j].PositionX - myworld.player.PositionX)+(myworld.monsters[j].Positiony - myworld.player.Positiony)*(myworld.monsters[j].Positiony - myworld.player.Positiony))<xmin) then
          begin
            xmin:=sqrt((myworld.monsters[j].PositionX - myworld.player.PositionX)*(myworld.monsters[j].PositionX - myworld.player.PositionX)+(myworld.monsters[j].Positiony - myworld.player.Positiony)*(myworld.monsters[j].Positiony - myworld.player.Positiony));
            min := j;
          end;

				shoot(myworld, myworld.monsters[min].PositionX - myworld.player.PositionX, myworld.monsters[min].PositionY - myworld.player.PositionY);
				break;
			end;	
	end;

end.
