#pragma once
#include "socket.h"
#include "simpleclass.h"
#include <cstdlib>
#include <cstdio>

#ifdef _WIN32
#include <windows.h>
#endif

class World{
	private:
		Socket socket;
#ifdef _WIN32
		HANDLE ghMutex;
#endif
	public:
		static const int MAXMONSTERS = 256;
		static const int MAXMISSILES = 64;

		CPlayer player;
		CMonster monsters[MAXMONSTERS];
		CMissile missiles[MAXMISSILES];


		World(const char *ip , int port);
		World(int port);
		void makeMove();
		void getMove();
		void sendWorld();
		void readFrameFromFile(FILE *);
		void writeFrameToFile(FILE *);
		void run(float _vx, float _vy);
		void shoot(float _shootx, float _shooty);
		void lock();
		void unlock();
		~World();
};
