#include <cstdio>
#include <cstring>
#include <string>
#include <fstream>
#include <vector>
#include <cassert>
#include <iostream>
#include <sstream> 
#define FILENAME "simpleclass" 
typedef char sstring[1024];
sstring id_, classname_, name_, type_;
std::string id, classname, name, type;
std::vector < std::string > names, types;
std::string language;
std::fstream cpp;
std::ostringstream ss;
std::string pt(std::string type){
	if (type == "int")
		return "Longint";
	if (type == "float")
		return "Single";
}

void printDef(std::ostream &out, std::string pref = "\t"){
	for ( unsigned int i = 0; i < names.size(); i++){
		if (language == "cpp" || language == "java")
			out << pref << types[i] << " " << names[i] << ";\n";
		if (language == "pascal")
			out << pref << names[i] << " : " << pt(types[i]) << ";\n";
	}
}

void printRead(std::ostream &out, std::string pref = "\t"){
	for ( unsigned int i = 0; i < names.size(); i++){
		if (language == "pascal"){
			if (types[i] == "int")
				out << pref << names[i] << " := nextInt;\n"; 
			if (types[i] == "float")
				out << pref << names[i] << " := nextFloat;\n"; 
		}
		if (language == "cpp" || language == "java"){
			if (types[i] == "int")
				out << pref << names[i] << " = socket.nextInt();\n";
			if (types[i] == "float")
				out << pref << names[i] << " = socket.nextFloat();\n";
		}
	}
}

void printWrite(std::ostream &out, std::string pref = "\t"){
	for ( unsigned int i = 0; i < names.size(); i++){
		if (language == "pascal"){
			if (types[i] == "int")
				out << pref << "writeInt(m." << names[i] << ");\n"; 
			if (types[i] == "float")
				out << pref << "writeFloat(m." << names[i] << ");\n"; 
		}
		if (language == "cpp" || language == "java"){
			if (types[i] == "int")
				out << pref << "socket.writeInt("<< names[i] << ");\n";
			if (types[i] == "float")
				out << pref << "socket.writeFloat("<< names[i] << ");\n";
		}
	}
}

void genPre(){
	if (language == "cpp"){
		cpp.open(FILENAME".cpp", std::ios::out);
		cpp << "#include \"socket.h\"\n";
		cpp << "#include \""FILENAME".h\"\n\n";
		assert(freopen(FILENAME".h", "w", stdout) != NULL);
		std::cout << "#ifndef _"FILENAME"_h\n";
		std::cout << "#define _"FILENAME"_h\n";
		std::cout << "class Socket;\n";
	}

	if (language == "java"){
	}

	if (language == "pascal"){
		assert(freopen(FILENAME".pp", "w", stdout) != NULL);
		std::cout << "unit "FILENAME";\n";
		std::cout << "Interface\n";
	}
}

void genPost(){
	if (language == "cpp"){
		std::cout << "#endif /* _"FILENAME"_h */\n";
		cpp.close();
	}
	if (language == "pascal"){
		std::cout << "Implementation\n\n";
		std::cout << "uses socketWrapper;\n\n";
		std::cout << ss.str();
		std::cout << "begin\n";
		std::cout << "end.\n";
	}
}

void genClass(){
	if (language == "cpp"){
		std::cout << "class " << classname << "{\n";
		std::cout << "\tpublic:\n";
		printDef(std::cout);
		std::cout << "\tvoid read(Socket &socket);\n";
		std::cout << "\tvoid write(Socket &socket) const;\n";
		std::cout << "};\n\n";
		cpp << "void " << classname << "::" << "read(Socket &socket){\n";
		printRead(cpp);
		cpp << "}\n\n";
		cpp << "void " << classname << "::" << "write(Socket &socket) const{\n";
		printWrite(cpp);
		cpp << "}\n\n";
	}
	if (language == "java"){
		cpp.open((classname + ".java").c_str(), std::ios::out);
		cpp << "import java.io.IOException;\n\n";
		cpp << "public class " << classname << "{\n";
		printDef(cpp, "\tpublic ");
		cpp << "\tpublic void read(WSOnet.Socket socket) throws IOException{\n";
		printRead(cpp, "\t\t");
		cpp << "\t}\n\n";
		cpp << "\tpublic void write(WSOnet.Socket socket) throws IOException{\n";
		printWrite(cpp, "\t\t");
		cpp << "\t}\n\n";
		cpp << "}\n\n";
		cpp.close();

	}
	if (language == "pascal"){
		std::cout << "Type T" << classname << " = Record\n";
		printDef(std::cout, "\t");
		std::cout << "end;\n\n";
		std::cout << "procedure Read" << classname << "FromSocket(var m : T" << classname << ");\n";
		std::cout << "procedure Write" << classname << "ToSocket(var m : T" << classname << ");\n";

		ss << "procedure Read" << classname << "FromSocket(var m : T" << classname << ");\n";
		ss << "begin\n";
		printRead(ss, "\tm.");
		ss << "end;\n\n";
		ss << "procedure Write" << classname << "ToSocket(var m : T" << classname << ");\n";
		ss << "begin\n";
		printWrite(ss);
		ss << "end;\n\n";

	}
}

int main(int argc, char * argv[]){
	if (argc != 3){
		printf("Ussage ./genclass filename language\nlanguage = {pascal, java,cpp}\n");
		return 1;
	}
	language = argv[2];
	if (language != "pascal" && language != "cpp" && language != "java"){
		printf("Unknown language. {pascal, java, cpp}\n");
		return 1;
	}
	if (!freopen(argv[1], "r", stdin)){

		printf("Can't open file\n");
		return 1;
	}
	genPre();
	while (scanf("%s%s", id_, classname_) == 2){
		classname = classname_;
		id = id_;

		assert(id == "class");
		while (true){
			assert(scanf("%s", name_) == 1);
			name = name_;
			if (name == "end"){
				genClass();
				names.clear();
				types.clear();
				break;

			}else{
				assert(scanf(" : %s", type_) > 0);
				type = type_;
				assert(type == "int" || type == "float");
				names.push_back(name);
				types.push_back(type);
			}
		}
	}
	genPost();
	return 0;
}
