#ifndef GRID_FOR_COLLISION_ACCELERATION_913876
#define GRID_FOR_COLLISION_ACCELERATION_913876
//grid acceleration structure for collision detection

#include "Global.h"
#include "GeomObjects.h"
#include "Entities.h"

struct Grid {
	typedef Entity * Element;
	typedef std::vector<Element> Cell;
	static const int CELLS = GRID_SIZE;

	Cell matr[CELLS][CELLS];

	inline void Clear() {
		for (int i = 0; i<CELLS; i++) for (int j = 0; j<CELLS; j++) matr[i][j].clear();
	}

	inline Cell *operator[] (int i) { return matr[i]; }
	inline const Cell *operator[] (int i) const { return matr[i]; }
};

#endif
