#ifndef WEAPON_HEADER_321987
#define WEAPON_HEADER_321987

#include "Global.h"
struct Entity;
struct Missile;

struct Cooldown {
	//remaining timer time
	double remaining;
	//time between actions
	double period;

	inline Cooldown(double _period) : period(_period), remaining(_period) {}
	inline Cooldown(double _period, double _remaining) : period(_period), remaining(_remaining) {}
	void PassTime(double deltatime);
	bool TimeToAct();
	void Nullify();
};

struct MeleeWeapon {
	//controls timing
	Cooldown cooldown;
	//bite damage per hit
	double bitedamage;


	inline MeleeWeapon(double _period, double _damage)
		 : cooldown(_period), bitedamage(_damage) {}

	bool Bite(Entity *ent);
};

struct RangedWeapon {
	//controls timing
	Cooldown cooldown;

	//bullet damage per hit
	double bulletdamage;
	//overall bullet damage
	double bullethitpoints;
	//velocity of bullets
	double bulletvelocity;
	//radius of bullet
	double bulletradius;

	inline RangedWeapon(double _period, double _bradius, double _bvelocity, double _bdamage, double _bhitpoints)
		 : cooldown(_period)
		 , bulletradius(_bradius), bulletvelocity(_bvelocity), bulletdamage(_bdamage), bullethitpoints(_bhitpoints) {}

	Missile *Shoot(double2 position, double2 direction);
};

#endif
